import { defineComponent, props, setup, $prefix, $props, $setup } from '@opentinyvue/vue-common';
import { renderless, api } from '@opentinyvue/vue-renderless/date-picker-mobile/vue';
import Button from '@opentinyvue/vue-button';
import TimePickerMobile from '@opentinyvue/vue-time-picker-mobile';
import ActionSheet from '@opentinyvue/vue-action-sheet';
import RecycleScroller from '@opentinyvue/vue-recycle-scroller';
import { t } from '@opentinyvue/vue-locale';

function normalizeComponent(scriptExports, render, staticRenderFns, functionalTemplate, injectStyles, scopeId, moduleIdentifier, shadowMode) {
  var options = typeof scriptExports === "function" ? scriptExports.options : scriptExports;
  if (render) {
    options.render = render;
    options.staticRenderFns = staticRenderFns;
    options._compiled = true;
  }
  var hook;
  if (injectStyles) {
    hook = injectStyles;
  }
  if (hook) {
    if (options.functional) {
      options._injectStyles = hook;
      var originalRender = options.render;
      options.render = function renderWithStyleInjection(h, context) {
        hook.call(context);
        return originalRender(h, context);
      };
    } else {
      var existing = options.beforeCreate;
      options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
    }
  }
  return {
    exports: scriptExports,
    options
  };
}

function _extends() {
  return _extends = Object.assign ? Object.assign.bind() : function(n) {
    for (var e = 1; e < arguments.length; e++) {
      var t2 = arguments[e];
      for (var r in t2) ({}).hasOwnProperty.call(t2, r) && (n[r] = t2[r]);
    }
    return n;
  }, _extends.apply(null, arguments);
}
var render$2 = function render$22() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    staticClass: "w-full flex"
  }, [_vm._t("default", function() {
    return [_vm._v(_vm._s(_vm.data.value))];
  }, {
    "data": _vm.data
  })], 2);
};
var staticRenderFns$2 = [];
var __vue2_script$2 = {
  inheritAttrs: false,
  components: {},
  props: {
    data: Object
  }
};
var __cssModules$2 = {};
var __component__$2 = /* @__PURE__ */ normalizeComponent(__vue2_script$2, render$2, staticRenderFns$2, false, __vue2_injectStyles$2);
function __vue2_injectStyles$2(context) {
  for (var o in __cssModules$2) {
    this[o] = __cssModules$2[o];
  }
}
var Option = /* @__PURE__ */ function() {
  return __component__$2.exports;
}();
var __vue2_script$1 = defineComponent({
  components: {
    TinyOption: Option,
    TinyActionSheet: ActionSheet,
    TinyTimePickerMobile: TimePickerMobile,
    TinyRecycleScroller: RecycleScroller,
    TinyButton: Button
  },
  emits: ["click", "confirm", "update:visible", "update:modelValue", "time-confirm"],
  props: [].concat(props, ["modelValue", "visible", "title", "type", "lockScroll", "pickerOptions", "customClass", "clearable", "step", "rangeSeparator", "endPlaceholder", "showTimeSecond"]),
  setup: function setup$1(props2, context) {
    return setup({
      props: props2,
      context,
      renderless,
      api
    });
  }
});
var render$1 = function render$12() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    attrs: {
      "data-tag": "tiny-date-picker-mobile"
    }
  }, [_c("tiny-action-sheet", {
    ref: "actionSheet",
    attrs: {
      "title": _vm.title,
      "custom-class": _vm.m("h-full max-h-full rounded-none min-h-[95vh]", _vm.customClass),
      "lock-scroll": _vm.lockScroll,
      "visible": _vm.visible
    },
    on: {
      "update:visible": function updateVisible($event) {
        return _vm.$emit("update:visible", $event);
      }
    },
    scopedSlots: _vm._u([_vm.clearable ? {
      key: "header-left",
      fn: function fn() {
        return [_c("div", {
          staticClass: "cursor-pointer text-color-brand",
          on: {
            "click": _vm.clear
          }
        }, [_vm._v(_vm._s(_vm.t("ui.datepicker.clear")))])];
      },
      proxy: true
    } : null], null, true)
  }, [_c("div", {
    class: ["flex flex-col flex-auto h-full"],
    attrs: {
      "data-tag": "tiny-date-picker-inner"
    }
  }, [_c("div", {
    staticClass: "flex leading-6 py-2.5 px-4 text-sm items-center text-center border-b border-color-bg-4 shadow-sm",
    attrs: {
      "data-tag": "date-picker-header"
    }
  }, _vm._l(7, function(item, index) {
    return _c("div", {
      key: index,
      staticClass: "flex-1"
    }, [_vm._v(" " + _vm._s(_vm.t("ui.calendarBar.week." + index)) + " ")]);
  }), 0), _c("div", {
    ref: "datePickerBody",
    staticClass: "flex-auto overflow-hidden px-4",
    attrs: {
      "data-tag": "date-picker-body"
    }
  }, [_c("tiny-recycle-scroller", {
    ref: "recycleScroller",
    staticClass: "h-full scrollbar-size-0",
    style: {
      height: _vm.state.scrollerHeight ? _vm.state.scrollerHeight + "px" : null
    },
    attrs: {
      "key-field": "id",
      "items": _vm.state.months,
      "item-size": _vm.state.itemSize,
      "buffer": _vm.state.buffer
    },
    on: {
      "scroll-start": _vm.scrollStart,
      "scroll-end": _vm.scrollEnd
    },
    scopedSlots: _vm._u([{
      key: "default",
      fn: function fn(scopeSlots) {
        return [_c("div", {
          staticClass: "mt-4"
        }, [_c("div", {
          staticClass: "text-xl leading-7 text-color-text-primary"
        }, [_vm._v(" " + _vm._s(_vm.formatDate(scopeSlots.item.yearMonth, _vm.t("ui.datepicker.yearMonth", {
          year: "yyyy",
          month: "MM"
        }))) + " ")]), _c("div", {
          staticClass: "text-center leading-9 text-xs font-medium"
        }, _vm._l(_vm.getWeeksByMonth(scopeSlots.item.yearMonth), function(item, week) {
          return _c("div", {
            key: week,
            class: ["flex mt-2"]
          }, _vm._l(7, function(item2, index) {
            return _c("div", {
              key: index,
              class: ["flex-1 h-9 cursor-pointer", index === 0 || index === 6 ? "text-color-text-placeholder" : "text-color-text-primary"],
              on: {
                "click": function click($event) {
                  $event.stopPropagation();
                  return _vm.selectOption({
                    value: scopeSlots.item.yearMonth,
                    index: index + week * 7
                  });
                }
              }
            }, [_c("tiny-option", {
              attrs: {
                "data": _vm.getDate({
                  yearMonth: scopeSlots.item.yearMonth,
                  index: index + week * 7
                })
              },
              scopedSlots: _vm._u([{
                key: "default",
                fn: function fn2(_ref) {
                  var data = _ref.data;
                  return [_c("div", {
                    class: ["flex-1", {
                      "bg-color-info-primary-subtler": !data.disabled && _vm.state.date.length === 2 && ["end", "inner"].includes(_vm.getSelectedPosition(data.value))
                    }, {
                      "rounded-l": index === 0
                    }]
                  }), _c("div", {
                    class: _vm.m("w-9 h-9", {
                      "text-color-brand border-0.5 border-current rounded": data.isToday
                    }, {
                      "bg-color-info-primary-subtler": ["inner"].includes(_vm.getSelectedPosition(data.value))
                    }, {
                      "bg-color-brand text-color-text-inverse rounded": ["start", "end"].includes(_vm.getSelectedPosition(data.value))
                    }, {
                      "bg-white text-color-text-disabled cursor-not-allowed": data.disabled
                    })
                  }, [_vm._t("default", function() {
                    return [_vm._v(" " + _vm._s(data.day) + " ")];
                  }, {
                    "data": data
                  })], 2), _c("div", {
                    class: ["flex-1", {
                      "bg-color-info-primary-subtler": !data.disabled && _vm.state.date.length === 2 && _vm.state.selected.length > 1 && ["start", "inner"].includes(_vm.getSelectedPosition(data.value))
                    }, {
                      "rounded-r": index === 6
                    }]
                  })];
                }
              }], null, true)
            })], 1);
          }), 0);
        }), 0)])];
      }
    }])
  })], 1), _c("div", {
    staticClass: "flex flex-none flex-col items-center justify-center p-4 border-t border-color-bg-4 shadow-sm",
    attrs: {
      "data-tag": "date-picker-footer"
    }
  }, [["datetimerange", "daterange"].includes(_vm.type) && _vm.state.date.length ? _c("div", {
    staticClass: "w-full",
    attrs: {
      "data-tag": "rang-box"
    }
  }, [_c("div", {
    staticClass: "w-full flex mb-4 h-6 leading-6 text-base text-center"
  }, [_c("div", {
    staticClass: "min-w-[theme(spacing.32)]"
  }, [_vm._v(" " + _vm._s(_vm.formatDate(_vm.state.date[0], _vm.t("ui.datepicker.yearMonthDay", {
    year: "yyyy",
    month: "MM",
    day: "dd"
  }))) + " ")]), _c("div", {
    staticClass: "flex-auto min-w-[theme(spacing.4)]"
  }, [["datetimerange"].includes(_vm.type) ? _c("div", {
    staticClass: "h-9 border-l-0.5 inline-block rotate-45 relative top-6 border-color-bg-2"
  }) : _c("div", {
    staticClass: "text-center"
  }, [typeof _vm.rangeSeparator === "string" ? [_vm._v(_vm._s(_vm.rangeSeparator))] : _c(_vm.rangeSeparator, {
    tag: "component"
  })], 2)]), _c("div", {
    staticClass: "min-w-[theme(spacing.32)]"
  }, [_vm.state.btnDisabled ? _c("span", {
    staticClass: "text-color-icon-placeholder"
  }, [_vm._v(_vm._s(_vm.endPlaceholder))]) : _c("span", [_vm._v(_vm._s(_vm.formatDate(_vm.state.date[1], _vm.t("ui.datepicker.yearMonthDay", {
    year: "yyyy",
    month: "MM",
    day: "dd"
  }))))])])]), _vm.type === "datetimerange" ? _c("div", {
    staticClass: "w-full h-9 flex mb-4 leading-9 text-base text-center"
  }, [_c("div", {
    staticClass: "w-32 bg-color-bg-2",
    on: {
      "click": function click($event) {
        $event.stopPropagation();
        return _vm.timeToggle(0);
      }
    }
  }, [_vm._v(_vm._s(_vm.state.timeList[0].join(":")))]), _c("div", {
    staticClass: "flex-auto min-w-[theme(spacing.4)]"
  }), _c("div", {
    staticClass: "w-32 bg-color-bg-2",
    on: {
      "click": function click($event) {
        $event.stopPropagation();
        return _vm.timeToggle(1);
      }
    }
  }, [_vm._v(_vm._s(_vm.state.timeList[1].join(":")))])]) : _vm._e()]) : _vm._e(), ["datetime"].includes(_vm.type) && _vm.state.date ? _c("div", {
    staticClass: "w-full",
    attrs: {
      "data-tag": "datetime-box"
    }
  }, [_c("div", {
    staticClass: "w-full flex mb-4 leading-6 text-base text-center"
  }, [_c("div", {
    staticClass: "min-w-[theme(spacing.32)]"
  }, [_vm._v(" " + _vm._s(_vm.formatDate(_vm.state.date, _vm.t("ui.datepicker.yearMonthDay", {
    year: "yyyy",
    month: "MM",
    day: "dd"
  }))) + " ")]), _c("div", {
    staticClass: "flex-auto min-w-[theme(spacing.4)]"
  }), _c("div", {
    staticClass: "w-32 bg-color-bg-2",
    on: {
      "click": function click($event) {
        $event.stopPropagation();
        return _vm.timeToggle(0);
      }
    }
  }, [_vm._v(_vm._s(_vm.state.timeList[0].join(":")))])])]) : _vm._e(), _c("div", {
    staticClass: "w-full text-center"
  }, [_c("tiny-button", {
    attrs: {
      "tiny_mode": "mobile-first",
      "custom-class": "w-full",
      "disabled": _vm.state.btnDisabled,
      "type": "primary",
      "size": "medium",
      "reset-time": 0
    },
    on: {
      "click": _vm.confirm
    }
  }, [_vm._v(" " + _vm._s(_vm.t("ui.button.confirm")) + " ")])], 1)])])]), _c("tiny-time-picker-mobile", {
    attrs: {
      "title": _vm.t("ui.datepicker.selectTime"),
      "step": _vm.step,
      "show-seconds": _vm.showTimeSecond,
      "visible": _vm.state.timeVisible
    },
    on: {
      "update:visible": function updateVisible($event) {
        _vm.state.timeVisible = $event;
      },
      "confirm": _vm.timeConfirm
    },
    model: {
      value: _vm.state.time,
      callback: function callback($$v) {
        _vm.$set(_vm.state, "time", $$v);
      },
      expression: "state.time"
    }
  })], 1);
};
var staticRenderFns$1 = [];
var __cssModules$1 = {};
var __component__$1 = /* @__PURE__ */ normalizeComponent(__vue2_script$1, render$1, staticRenderFns$1, false, __vue2_injectStyles$1);
function __vue2_injectStyles$1(context) {
  for (var o in __cssModules$1) {
    this[o] = __cssModules$1[o];
  }
}
var NormalTemplate = /* @__PURE__ */ function() {
  return __component__$1.exports;
}();
var __vue2_script = defineComponent({
  components: {
    TinyOption: Option,
    TinyActionSheet: ActionSheet,
    TinyRecycleScroller: RecycleScroller,
    TinyButton: Button
  },
  emits: ["click", "confirm", "update:visible", "update:modelValue", "time-confirm"],
  props: [].concat(props, ["modelValue", "visible", "title", "type", "lockScroll", "pickerOptions"]),
  setup: function setup2(props2, context) {
    return setup({
      props: props2,
      context,
      renderless,
      api
    });
  }
});
var render = function render2() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    attrs: {
      "data-tag": "tiny-date-picker-mobile year-month"
    }
  }, [_c("tiny-action-sheet", {
    attrs: {
      "custom-class": "h-full",
      "title": _vm.title,
      "lock-scroll": _vm.lockScroll,
      "visible": _vm.visible
    },
    on: {
      "update:visible": function updateVisible($event) {
        return _vm.$emit("update:visible", $event);
      }
    }
  }, [_c("div", {
    class: ["flex flex-col overflow-hidden"],
    attrs: {
      "data-tag": "tiny-date-picker-inner"
    }
  }, [_c("div", {
    ref: "datePickerBody",
    staticClass: "flex-auto overflow-hidden px-4",
    attrs: {
      "data-tag": "date-picker-body"
    }
  }, [_c("tiny-recycle-scroller", {
    ref: "recycleScroller",
    staticClass: "h-full scrollbar-size-0",
    style: {
      height: _vm.state.scrollerHeight ? _vm.state.scrollerHeight + "px" : null
    },
    attrs: {
      "key-field": "id",
      "items": _vm.state.computedYears,
      "item-size": _vm.state.itemSize,
      "buffer": _vm.state.buffer
    },
    on: {
      "scroll-start": _vm.scrollStart,
      "scroll-end": _vm.scrollEnd
    },
    scopedSlots: _vm._u([{
      key: "default",
      fn: function fn(scopeSlots) {
        return [_c("div", {
          staticClass: "mt-4"
        }, [_c("div", {
          staticClass: "text-xl leading-7"
        }, [_vm._v(_vm._s(scopeSlots.item.year) + _vm._s(_vm.t("ui.datepicker.year")))]), _c("div", {
          staticClass: "text-center leading-9 text-xs font-medium"
        }, _vm._l(2, function(v, row) {
          return _c("div", {
            key: row,
            class: ["flex mt-2"]
          }, _vm._l(6, function(v2, col) {
            return _c("div", {
              key: col,
              class: ["flex-1 h-9 cursor-pointer"],
              on: {
                "click": function click($event) {
                  $event.stopPropagation();
                  return _vm.selectOption({
                    value: scopeSlots.item.year,
                    index: row * 6 + col
                  });
                }
              }
            }, [_c("tiny-option", {
              attrs: {
                "data": _vm.state.years[scopeSlots.item.year][row * 6 + col]
              },
              scopedSlots: _vm._u([{
                key: "default",
                fn: function fn2(_ref) {
                  var data = _ref.data;
                  return [_c("div", {
                    class: ["flex-1", {
                      "bg-color-info-primary-subtler": !data.disabled && _vm.state.date.length === 2 && ["end", "inner"].includes(_vm.getSelectedPosition(data.value))
                    }]
                  }), _c("div", {
                    class: _vm.m("w-9 h-9", {
                      "text-color-brand border-0.5 border-current": data.isToday
                    }, {
                      "bg-color-info-primary-subtler": ["inner"].includes(_vm.getSelectedPosition(data.value))
                    }, {
                      "bg-color-brand text-color-text-inverse": ["start", "end"].includes(_vm.getSelectedPosition(data.value))
                    }, {
                      "bg-white text-color-text-disabled cursor-not-allowed": data.disabled
                    })
                  }, [_vm._t("default", function() {
                    return [_vm._v(" " + _vm._s(data.month) + " ")];
                  }, {
                    "data": data
                  })], 2), _c("div", {
                    class: ["flex-1", {
                      "bg-color-info-primary-subtler": !data.disabled && _vm.state.date.length === 2 && _vm.state.selected.length > 1 && ["start", "inner"].includes(_vm.getSelectedPosition(data.value))
                    }]
                  })];
                }
              }], null, true)
            })], 1);
          }), 0);
        }), 0)])];
      }
    }])
  })], 1), _c("div", {
    staticClass: "w-full flex-none flex flex-col items-center justify-center p-4 border-t border-color-bg-4 shadow-sm",
    attrs: {
      "data-tag": "date-picker-footer"
    }
  }, [["year-month-range"].includes(_vm.type) && _vm.state.date.length ? _c("div", {
    staticClass: "w-full",
    attrs: {
      "data-tag": "rang-box"
    }
  }, [_c("div", {
    staticClass: "w-full flex mb-4 h-6 leading-6 text-base text-center"
  }, [_c("div", {
    staticClass: "min-w-[theme(spacing.32)]"
  }, [_vm._v(" " + _vm._s(_vm.formatDate(_vm.state.date[0], _vm.t("ui.datepicker.yearMonth", {
    year: "yyyy",
    month: "MM"
  }))) + " ")]), _c("div", {
    staticClass: "flex-auto min-w-[theme(spacing.4)] justify-center"
  }, [_vm._v("~")]), _c("div", {
    staticClass: "min-w-[theme(spacing.32)]"
  }, [_vm.state.btnDisabled ? _c("span", {
    staticClass: "text-color-icon-placeholder"
  }, [_vm._v(_vm._s(_vm.t("ui.datepicker.endTime")))]) : _c("span", [_vm._v(_vm._s(_vm.formatDate(_vm.state.date[1], _vm.t("ui.datepicker.yearMonth", {
    year: "yyyy",
    month: "MM"
  }))))])])])]) : _vm._e(), _c("div", {
    staticClass: "w-full text-center"
  }, [_c("tiny-button", {
    attrs: {
      "tiny_mode": "mobile-first",
      "custom-class": "w-full",
      "disabled": _vm.state.btnDisabled,
      "type": "primary",
      "size": "medium",
      "reset-time": 0
    },
    on: {
      "click": _vm.confirm
    }
  }, [_vm._v(" " + _vm._s(_vm.t("ui.button.confirm")) + " ")])], 1)])])])], 1);
};
var staticRenderFns = [];
var __cssModules = {};
var __component__ = /* @__PURE__ */ normalizeComponent(__vue2_script, render, staticRenderFns, false, __vue2_injectStyles);
function __vue2_injectStyles(context) {
  for (var o in __cssModules) {
    this[o] = __cssModules[o];
  }
}
var YearMonthTemplate = /* @__PURE__ */ function() {
  return __component__.exports;
}();
var $constants = {
  TYPE: {
    DATE: "date",
    DATE_TIME: "datetime",
    DATE_RANGE: "daterange",
    DATE_TIME_RANGE: "datetimerange",
    YEAR_MONTH_RANGE: "year-month-range",
    YEAR_MONTH: "year-month"
  }
};
var template = function template2(mode, props2) {
  var _$constants$TYPE = $constants.TYPE, YEAR_MONTH_RANGE = _$constants$TYPE.YEAR_MONTH_RANGE, YEAR_MONTH = _$constants$TYPE.YEAR_MONTH;
  return [YEAR_MONTH_RANGE, YEAR_MONTH].includes(props2.type) ? YearMonthTemplate : NormalTemplate;
};
var DatePickerMobile = defineComponent({
  name: $prefix + "DatePickerMobile",
  props: _extends({}, $props, {
    _constants: {
      type: Object,
      default: function _default() {
        return $constants;
      }
    },
    modelValue: [Number, String, Array, Date],
    visible: {
      type: Boolean,
      default: false
    },
    title: String,
    type: {
      type: String,
      default: "date",
      validator: function validator(value) {
        return !value || ~Object.values($constants.TYPE).indexOf(value);
      }
    },
    clearable: {
      type: Boolean,
      default: false
    },
    lockScroll: {
      type: Boolean,
      default: true
    },
    pickerOptions: {
      type: Object,
      default: function _default2() {
        return {
          disabledDate: null
        };
      }
    },
    customClass: [String, Object, Array],
    step: {
      type: Object,
      default: function _default3() {
        return {
          hour: 1,
          minute: 1,
          second: 1
        };
      }
    },
    endPlaceholder: {
      type: String,
      default: function _default4() {
        return t("ui.datepicker.endTime");
      }
    },
    rangeSeparator: {
      type: [Object, String],
      default: "~"
    },
    showTimeSecond: {
      type: Boolean,
      default: true
    }
  }),
  setup: function setup3(props2, context) {
    return $setup({
      props: props2,
      context,
      template
    });
  }
});
var version = "2.21.0";
DatePickerMobile.model = {
  prop: "modelValue",
  event: "update:modelValue"
};
DatePickerMobile.install = function(Vue) {
  Vue.component(DatePickerMobile.name, DatePickerMobile);
};
DatePickerMobile.version = version;

export { DatePickerMobile as default };
